=== dist/pkgbuild/PKGBUILD ===
# Maintainer: NAKASHIMA, Makoto <makoto.nksm@gmail.com>

pkgname=lcov-util
pkgver=0.1.6
pkgrel=1
pkgdesc="Utility commands to operate and analyze LCOV trace file at blazingly fast."
url="https://github.com/gifnksm/lcov/"
depends=()
makedepends=('cargo')
arch=('i686' 'x86_64')
license=('MIT' 'APACHE')
source=(${pkgname}-${pkgver}.tar.gz::${url}/archive/lcov-util_v${pkgver}.tar.gz)
sha512sums=('1300151ee37781d459fb80518e55c1ae85e75c9dc87175954893dcccc039cb9a0c1316671a66c694e76922993651dd5402308d12125aaa0fe8d0292ed13adfdf')

build() {
  cd "lcov-${pkgname}_v${pkgver}"
  cargo build --release #--locked
}

check() {
  cd "lcov-${pkgname}_v${pkgver}"
  cargo test --release --locked
}

package() {
  cd "lcov-${pkgname}_v${pkgver}"
  install -Dm755 \
    "target/release/lcov-merge" \
    -t "${pkgdir}/usr/bin"
  install -Dm644 README.md -t "${pkgdir}/usr/share/doc/${pkgname}"
  install -Dm644 LICENSE-MIT -t "${pkgdir}/usr/share/licenses/${pkgname}"
}

# vim:set ts=2 sw=2 et:
